
load("~/R/scDEED/Seurat.RData")

umap_optimized = CreateDimReducObject(embeddings = readRDS('R/scDEED/PBMC/loadings_n80_m0.5.Rds'), key = 'umap_optimized', assay = 'RNA')
inDrops[['optimized_umap']] = umap_optimized
tsne_optimized = CreateDimReducObject(embeddings = readRDS('R/scDEED/PBMC/tSNEloadings_perplexity_inDrops320.Rds'), key = 'tsne_optimized', assay = 'RNA')
inDrops[['optimized_tsne']] = tsne_optimized

umap_optimized = CreateDimReducObject(embeddings = readRDS('R/scDEED/PBMC/loadings_n5_m0.5.Rds'), key = 'umap_optimized', assay = 'RNA')
Dropseq[['optimized_umap']] = umap_optimized
tsne_optimized = CreateDimReducObject(embeddings = readRDS('R/scDEED/PBMC/tSNEloadings_perplexity_Dropseq290.Rds'), key = 'tsne_optimized', assay = 'RNA')
Dropseq[['optimized_tsne']] = tsne_optimized

umap_optimized = CreateDimReducObject(embeddings = readRDS('R/scDEED/PBMC/loadings_n7_m0.2.Rds'), key = 'umap_optimized', assay = 'RNA')
SeqWell[['optimized_umap']] = umap_optimized
tsne_optimized = CreateDimReducObject(embeddings = readRDS('R/scDEED/PBMC/tSNEloadings_perplexity_SeqWell140.Rds'), key = 'tsne_optimized', assay = 'RNA')
SeqWell[['optimized_tsne']] = tsne_optimized
#### DropSeq, optimized perplexity = 290, optimized umap0.5 and nneighbors = 5
##seqwell, optimized perplexity =140, umap 0.2 and nneighbors 7
##indrops: perplexity 230, min.dist = 0.5 and nneighbors 80

pbmc = list('inDrops' = inDrops, 'seqwell' = SeqWell, 'dropseq' = Dropseq)
results = matrix(ncol = 3, nrow = 4)
colnames(results) = names(pbmc)
rownames(results) = c('tsne', 'optimized_tsne', 'umap', 'optimized_umap')
library(kernlab)
for(i in 1:3){
  for(k in 1:4){
    embeddings = Embeddings(pbmc[[i]], rownames(results)[k])
    sc = specc(embeddings, centers = 4)
    labels = pbmc[[i]]$CellType
    cm = table(sc@.Data,labels)
    cluster_assignment = sc@.Data
    new_assignment = c()
    for(s in 1:nrow(cm)){
      
      match = which(cm[s, ]==max(cm[s, ]))
      new_assignment[s] = colnames(cm)[match]
    }
    cluster_assignment = mapvalues(cluster_assignment, from = 1:nrow(cm), to = new_assignment)
    results[k, i] = ARI(cluster_assignment, labels)  
  }
}
results_ARI = results
colnames(results_ARI) = names(pbmc)

results = matrix(ncol = 3, nrow = 4)
colnames(results) = names(pbmc)
rownames(results) = c('tsne', 'optimized_tsne', 'umap', 'optimized_umap')

library(class)
for(i in 1:3){
  for(k in 1:4){
    embeddings = Embeddings(pbmc[[i]], rownames(results)[k])
    split = sample(1:nrow(embeddings), 0.5*nrow(embeddings))
    train = embeddings[-split, ]
    test = embeddings[split, ]
    s = knn(train,test = test, cl = pbmc[[i]]$CellType[-split], k = 4)
    results[k, i] = ARI(s, pbmc[[i]]$CellType[split])
  }
}
results_KNN = results


results = matrix(ncol = 3, nrow = 4)
colnames(results) = names(pbmc)
rownames(results) = c('tsne', 'optimized_tsne', 'umap', 'optimized_umap')

for(i in 1:3){
  for(s in 1:4){
  pbmc[[i]] <- FindNeighbors(object = pbmc[[i]], reduction = rownames(results)[s], dims = 1:2)
  pbmc[[i]] <- FindClusters(object = pbmc[[i]], verbose = FALSE, algorithm = 4, method = 'igraph')

##assign to cluster by maximum 
  
  cluster_assignment = as.character(pbmc[[i]]$seurat_clusters)
  cm = table(cluster_assignment, pbmc[[i]]$CellType)
  new_assignment = c()
  for(k in 1:nrow(cm)){
  
    match = which(cm[k, ]==max(cm[k, ]))
    new_assignment[k] = colnames(cm)[match]
  }
  cluster_assignment = mapvalues(cluster_assignment, from = 1:nrow(cm), to = new_assignment)
  results[s, i] = ARI(cluster_assignment, pbmc[[i]]$CellType)
  }
}


ASW = function(embeddings, labels){
  groups = unique(labels)
  distances = as.matrix(dist(embeddings))
  scores = c()
  for(i in 1:nrow(embeddings)){
    group_scores = c()
    for(j in groups){
      cells = which(labels == j)
      cells = cells[cells!=i]
      group_scores =c(group_scores, mean(distances[i, cells]))
    }
    names(group_scores) = groups
    a = group_scores[labels[i]]
    group_scores = group_scores[-which(names(group_scores)==labels[i])]
    b = min(group_scores)
    scores[i] = (b-a)/max(c(a, b))
  }
  return(scores)
}

test = Embeddings(pbmc[[1]], 'umap')[1:20, ]
ASW(test, as.character(pbmc[[1]]$CellType[1:20]))

results = matrix(ncol = 3, nrow = 4)
colnames(results) = names(pbmc)
rownames(results) = c('tsne', 'optimized_tsne', 'umap', 'optimized_umap')

for(i in 1:3){
  for(k in 1:4){
    embeddings = Embeddings(pbmc[[i]], rownames(results)[k])
    scores = ASW(embeddings, pbmc[[i]]$CellType)
    results[k, i] = mean(scores)
  }
}
